#ifndef _TYPE_H
#define _TYPE_H

typedef unsigned char U8;                       /* 8bit unsigned integer */
typedef unsigned short int U16;                 /* 16bit unsigned integer */
typedef unsigned int U32;                       /* 32bit unsigned integer */
typedef unsigned long long int U64;             /* 64bit unsigned integer */

typedef signed char S8;                         /* 8bit signed integer  */
typedef signed short int S16;                   /* 16bit signed integer */
typedef signed int S32;                         /* 32bit signed integer */
typedef signed long long int S64;               /* 64bit signed integer */

typedef volatile unsigned char VU8;             /* 8bit unsigned volatile't integer   */
typedef volatile unsigned short int VU16;       /* 16bit unsigned volatile't integer  */
typedef volatile unsigned int VU32;             /* 32bit unsigned volatile't integer  */
typedef volatile unsigned long long int VU64;   /* 64bit unsigned volatile't integer  */

typedef volatile signed char VS8;               /* 8bit signed volatile't integer  */
typedef volatile signed short int VS16;         /* 16bit signed volatile't integer */
typedef volatile signed int VS32;               /* 32bit signed volatile't integer */
typedef volatile signed long long int VS64;     /* 64bit signed volatile't integer */

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE  1
#endif

typedef struct file_handle_tag
{
    char name[1024];         /* File or Folder, absolute path goes here */
    U64 fileBase;            /* Raw sector on device                    */
    U32 offset;              /* Offset in the file                      */
    U32 size;                /* size of the file                        */
    S32 fileAttrib;          /* IS_FILE or IS_DIR                       */ 
    S32 status;              /* is the device ok                        */
} FILE_HANDLE_TYPE;

/* File type */
typedef enum
{
  IS_FILE = 0,
  IS_DIR,
  IS_SPECIAL
} FILE_TYPES_ENUM;

typedef struct usb_data_tag
{
    U32 offset;    /* Offset in the file */
    U32 size;      /* size to read       */
} USB_DATA_REQ_TYPE;


#endif
